Tue Jan 23 23:02:13 2001  Nobuyoshi Nakada  <nobu.nakada@nifty.ne.jp>

	* MANIFEST (ChangeLog, install.rb): added.

Tue Jan 23 22:57:12 2001  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: 0.7.9 release, trivial features.

Tue Jan 23 22:51:22 2001  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb (OptionParser::LastModified): added.

Tue Jan 23 22:48:44 2001  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* install.rb: take non-option argument as destdir.

2001-01-23  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* install.rb: install from the directory the script is located.

	* install.rb: added `--quiet' option. defaulted to verbose.

	* optparse.rb: error handle in fake main code.

	* optparse.rb: avoid parse error on 1.7.2 2001-01-22 too.

	* README.en, README.ja: how to install non-default place.

	* install.rb: use `FalseClass' explicitly for `-n' option.

	* install.rb: make `more' argument to option.

	* install.rb: parse any non-option arguemnts.

	* install.rb: New file.

	* optparse.rb: strip directory portion for default program name.

	* optparse.rb: avoid parse error on 1.7.2 2001-01-22.

2001-01-22  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser::ParseError): instances have each
	  reason to override default reason.

	* optparse.rb: surounded release code with parentheses.

	* optparse.rb(OptionParser#version, OptionParser#release):
	  new attributes.

	* optparse.rb(OptionParser#ver): returns version string.

2001-01-08  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* README.ja, README.en: added install-more

	* GNUmakefile: mode is octal.

	* optparse/uri.rb: honors preloaded URI class.

	* optparse/uri.rb: two URI libraries' factory methods are different.

	* optparse/uri.rb: should check if argument is omitted.

	* optparse/uri.rb: ayURI needs to be wrapped with an Array.

	* optparse.rb: 0.7.8 release

	* optparse.rb(<OptionParser.inc, OptionParser#inc): added.

2001-01-07  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: acceptable patterns.

	* optparse.rb(OptionParser#complete): has raised
	  `OptionParser::AmbiguousOption' wrongly, not but
	  `OptionParser::InvalidOption'(0.7.6.2 bug).

2001-01-06  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: patch from Hugh Sasse Staff Elec Eng <hgs@dmu.ac.uk>

	* optparse.ja.rd(OptionParser::Filling): modified.

	* GNUmakefile: includes Makerules from cwd, if present.

	* GNUmakefile(install-more): new target, install sub files.

	* MANIFEST(Makerules): added

	* MANIFEST(comment): added

	* README.ja, README.en: New file.

	* MANIFEST: patch from Hugh Sasse Staff Elec Eng <hgs@dmu.ac.uk>

	* optparse/uri.rb: New file.

2000-12-30  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: allows space for separator between switch and
	  argument.

	* optparse.rb: prefer return from block not but catch/throw.

2000-12-26  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* opttest.rb: keyword switch sample.

	* optparse.rb: fixed keyword completion and array

2000-12-20  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* opttest.rb: added fixed size array sample.

	* optparse.rb(OptionParser::load): doesn't raise even if `HOME'
	  environment variable is not set, and returns `true'/`false'.

	* optparse.rb: 0.7.6 release.

2000-12-18  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* opttest.rb, optparse.rb: distinguish between no argument and
	  empty list for `Array'.

	* optparse.rb: uses `block_given?' instead of `iterator?'.

	* optparse.rb: avoid warnings with `-w'.

2000-12-14  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser::Version): now `Comparable'.

	* optparse.rb(OptionParser::Release): added.

2000-07-17  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(Class#module_function): no longer available.

	* optparse.rb: 0.7.5 release.

2000-06-19  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* MANIFEST(shellwords): added.

	* optparse.rb: allows `Module' for option class not only `Class'.

	* optparse.rb(OptionParser::load, OptionParser::environment):
	  added experimentally.

2000-06-14  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse/shellwords.rb: Initial revision.

2000-05-21  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.ja.rd, optparse.rb(OptionParser#program_name): added.

	* MANIFEST(rlog2rd.rb): removed.

2000-05-15  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* GNUmakefile: Initial revision.

	* optparse.rb(OptionParser::ParseError#recover): added document,
	  and pushes `@args' back at once.

2000-05-07  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.ja.rd, optparse.rb(OptionParser#switch): removed
	  `check_twice'.

	* MANIFEST: added 2 step parse sample.

	* optparse.rb(OptionParser::summarize): uses `visit'.

	* cmd-ls.rb, cmd.rb: New file.

	* optparse.ja.rd: Re-released 0.7.3.0.

	* optparse.rb(OptionParser.yieldproc): Renamed `safe_call'.

	* opttest.rb(parse!): used `opts' insted of `ARGV'.

	* MANIFEST, optparse.ja.rd:

	* optparse.rb: Fixed arity problem(I hope!!).

2000-05-06  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.ja.rd(Class definitions): indexed.

	* optparse.rb(OptionParser::Arguable#options): refined documents.

	* optparse.rb(OptionParser::Arguable#options): argument to char
	  range option was wrong.

	* optparse.ja.rd(<OptionParser::Arguable#options): rewrite.

	* optparse.rb: used ((:name:)) format for class/module description
	  in headlines.

	* optparse.rb: not convert `nil' to numerics.

2000-05-05  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* MANIFEST: released with revision 0.7.2.0

	* optparse.rb: added example section and documents.

	* optparse.rb(Proc#call): Fixed arity problem.

	* optparse.ja.rd: Initial revision.

	* optparse.rb: Passes an array to `proc' directly, without *
	  expansion.

2000-05-04  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: Modified rest array argument passing.

	* optparse.rb(OptionParser::Filling): module which extends method
	  `fill' like as `Array'.

	* optparse.rb(OptionParser::OptionMap): Added.

	* optparse.rb(OptionParser::CompletingHash): Keyword completion
	  uses only `Hash' now.

	* optparse.rb: Missed argument string in option summary.

	* opttest.rb: released with revision 0.7.2.0

	* optparse.rb: Changed parameters format.

	* optparse.rb(OptionParser::Switch.guess): Moved to class methods
	  section.

	* optparse.rb(OptionParser::check_twice): Added.

	* optparse.rb: Guards `[nil]' while passing to proc.

	* optparse.rb(Array): Added argument check.

2000-05-03  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser::List): Merged methods `match' and
	  `complete'.

	* optparse.rb(OptionParser#complete, OptionParser::List#complete):
	  take arguments that specifys which table used, and optional
	  arguments for completion.

	* optparse.rb: Character class options regexp was wrong.

	* getopts.test: adding documents

	* optparse.rb: Added character class short option.

	* optparse.rb: When no matched options found, `AmbiguousOption'
	  raised instead of `InvalidOption'.

	* optparse.rb: Indented `*'list under `:'list.

	* optparse.rb: Added a few documents.

	* optparse.rb: Categorized `initialize' methods to class methods
	  in documents.

	* optparse.rb: Generally uses `convert' method of `pattern' for
	  conversion.

	* optparse.rb(OptionParser::FillingHash): Added.

	* optparse.rb: Error recovery while invoking handlers.

	* optparse.rb(OptionParser#safe_call): Added.

	* optparse.rb: `to_f' and `oct' are unsafe without argument
	  check. `Float' and `OctalInteger' may deal raw argument while
	  conversion, and return 0(or 0.0) on `nil'.

	* optparse.rb: Made possible to completion to `Symbol'.

	* optparse.rb: Using method `OptionParser::Completion#convert' to
	  convert arguments.

	* optparse.rb(OptionParser::OptionalArgument): `nil' without
	  argument.

	* optparse.rb: Added documents.

2000-05-02  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: Removed change log.

	* optparse.rb(Completion): Modularized.

	* optparse.rb: Keyword argument class

	* optparse.rb(OptionParser::AmbiguousArgument): new exception.

	* optparse.rb: Fixed numeric regular expressions.

2000-05-01  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: Fixed default pattern.

2000-04-30  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: Defaulted short style argument classes to `Object'
	  or `TrueClass' according to argument specification.

	* getopts.test.en: Translated from Japanese version.

2000-04-29  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* getopts.test: Forgotten argument check(^^;

2000-04-28  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser::Arguable):
	    * renamed instance variable of @options to @optparse(might not
	      conflict).
	    * initializes instance variable.
	* optparse.rb(OptionParser::ParseError):
	    * `args' in message are joined with space instead of `='.
	    * `args' in inspection are joined with space.

	* optparse.rb: Long style options without argument may be boolean
	  flag.

	* getopts.test: Shows `f' and `g' themselves.

	* optparse.rb: long style option description designates default
	  argument class.

	* optparse.rb: couldn't recover error in the case of long style
	  completion for one-character option.

	* optparse.rb(Object): argument class passes argument string
	  itself.

	* optparse.rb: Avoiding `return from proc-closure' bug.

2000-04-24  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser::List): visitor.

	* FIRSTSTEP.ja.rd: Initial revision.

	* optparse.rb: Forgotten default pattern and converter for short
	  style option.

	* optparse.rb: Parse error recovery.

	* optparse.rb: Undocumented feature B-)

	* getopts.test: New file.

	* optparse.rb: Fixed document indentation.  Thanks to Tosh.

	* optparse.rb: Defaulted banner message.

2000-04-23  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(Switch classes): Added document.

	* optparse.rb: argument style without preceding `=' should be
	  `REQUIRED_ARGUMENT'.

	* optparse.rb(OptionParser::Switch#parse_arg): expands matched
	  data to array.

2000-04-22  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: Bug fix when no arguments given to switch using
	  converter.

2000-04-20  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser#order!): Modifying `argv' in option
	  handers is safe even while parsing crunched short options.

	* optparse.rb: Fixed exception when short option cannot be
	  completed.

	* optparse.rb(OptionParser::Arguable#options): When called as
	  iterator, rescues `ParseError' and returns nil with printing the
	  error message to STDERR.

	* optparse.rb: If no short options match, try completion with long
	  options.

	* optparse.rb(OptionParser::Switch::OptionalArgument): When no
	  arguments is passed, misparsed and resulted true, where it must
	  be nil.

2000-04-19  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: Forgotten changing guess_style to style.

	* optparse.rb(OptionParser::ParseError#inspect): Added returns
	  inspection string in format same as older versions.

	* optparse.rb(OptionParser::Switch.guess): moved from
	  `OptionParser::guess_style'.

2000-04-18  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: Short style options ignored after - or +, but now
	  ignore themselves.

	* optparse.rb: And boolean switches can take argument - and + as
	  false and true respectively.

	* optparse.rb(OptionParser::ParseError) changed to:
	  * have sub classes instead of style flag,
	  * have an attribute `arg' represents the argument string caused
	    the exception,
	  * and default stringizing methods `message' and `to_s' return
	    error message same as `to_str'.

2000-04-12  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: multiple argument style values.

2000-03-25  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser#new): takes block or return self.

	* optparse.rb(OptionParser::ArgumentStyle): now symbol.

	* optparse.rb: Option string with argument style is prior to ones
	  without style. Followings are equivalent now.
	    on("-f", "--flag=VALUE")
	    on("-f=VALUE", "--flag")

2000-03-24  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser::Arguable.options=): can be undefed by
	  setting nil or false.

2000-03-23  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: comments feedback from japanese document.

2000-03-10  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser::List.update): private.

	* optparse.rb(OptionParser::Arguable.options): takes block.

2000-02-21  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser::switch): Directly specified matchable
	  object is prior to accepted classes.

	* optparse.rb(OptionParser::Switch#parse_arg): relaxed matched
	  result.

	* optparse.rb: Now uses method index, and added some documents.

	* optparse.rb(OptionParser::Switch#parse_arg): Made safer.

	* optparse.rb(OptionParser::Switch#summarize, OptionParser::List#summarize): 
	  now same signature.

	* optparse.rb(OptionParser::Switch#pattern): Now anything can
	  match to String, not only Regexp.

2000-02-18  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: New release.

	* optparse.rb(OptionParser.with): added. behaves like as older
	  new.

	* optparse.rb: No use of dying.rb.

	* optparse.rb(OptionParser::Acceptables): added.

	* optparse.rb(OptionParser.switch): accepts also Method as
	  handler, not only Proc.

	* optparse.rb(OptionParser#new): Fixed doc as 0.6.

2000-02-14  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser#new): no longer evaluates block in its
	  context, just yields itself.

2000-02-12  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser#switch): Made public(was register),

	* optparse.rb(OptionParser::List#append, OptionParser::List#prepend):
	  added.

	* optparse.rb(OptionParser#on): accepts separated option argument
	  description, like as `=ARGUMENT'.

2000-02-05  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(exit): Removed to dying.rb.

	* optparse.rb(OptionParser::Arguable): added

	* optparse.rb(Array): Accepts comma separated list arguments.

2000-02-02  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: Not use return value from String#sub!.

	* optparse.rb: Used empty string for optional argument when
	  absent.(Revision 0.4.5.1)

2000-01-31  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser#on): can take just messages.

	* optparse.rb: Bug fix of boolean switch.

	* optparse.rb(OptionParser::List#atype): now holds pattern and
	  converter pairs. pattern and conv no longer exist.

2000-01-30  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: Passes matched substrings instead of `$~', to
	  converters.

	* optparse.rb(OptionParser#banner): added, and now
	  `OptionParser#new' takes summary formatting parameters.

	* optparse.rb(OptionParser::ParseError): explicits empty argument
	  not but missing argument. When an empty string given as optional
	  argument to short style,

	* optparse.rb(FalseClass): added, opposite of `TrueClass'.

2000-01-18  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: modified for 1.5.2

2000-01-15  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: failed long style completion for deferred switches.

2000-01-09  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: Changed default options list to singleton of
	  `OptionParser::List' instead class itself. There was no reasons
	  that it's must be.

	* optparse.rb(OptionParser#summary_width, OptionParser#summary_indent):
	  added.

	* optparse.rb(OptionParser::List::on): Removed back to
	  `OptionParser' again, and searches pattern and converter in the
	  stack.

	* optparse/time.rb: Initial revision.

	* optparse.rb(OptionParser::Switch#parse): no longer uses yielded
	  return value.

	* optparse.rb: Short style options support `=argument'.

	* optparse.rb(OptionParser#on): ignored argument class.

	* optparse.rb(OptionParser::ParseError): holds erred option, and
	  able to retry.

	* MANIFEST: optparse/time.rb added.

2000-01-08  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser#new, OptionParser#remove): Now has
	  stack structure.

	* optparse.rb(OptionParser#summarize): accepts formatting
	  parameters.

	* optparse.rb(OptionParser::InvalidOption): when raises,
	  `$!.message' holds whole erred option, including argument if
	  present.  So it's possible to retry with unshifting it.

2000-01-04  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser#order, OptionParser#permute, OptionParser#parse):
	  simplified. Now they're just front-ends for !-ed versions.

	* optparse.rb: Added MANIFEST.

	* optparse.rb: Made Example a link rather than included.

2000-01-03  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(TrueClass): Rewrote description in Acceptable
	  argument classes.

	* optparse.rb(OptionParser#on_head): added

	* optparse.rb: Multiple long-style option in one summary line.

	* optparse.rb: Relaxed check for ambiguous, but actually one
	  option.

	* optparse.rb(OptionParser::Switch#format): wrong local variable

	* optparse.rb: Rewrote RD.

	* optparse.rb(OptionParser#order!, OptionParser#permute!, OptionParser#parse!):
	  destructive parse methods.

	* optparse.rb(OptionParser.exit): miscellaneous utility.

1999-12-27  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb(OptionParser.accept, OptionParser.reject,
	  OptionParser#accept, OptionParser#reject): added

1999-12-22  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: Prefixed instance variables of OptionParser with '_' to prevent
	  interferences from attributes defined with `OptionParser#variable'.

	* optparse.rb(OptionParser#variable): Now returns attributes list.

1999-12-21  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: Adding boolean flag switch.

	* optparse.rb(OptionParser::ParseError#to_str): Added default
	  stringize method.

	* optparse.rb: Missing argument for short option caused no failure
	  and ignored silently.

	* optparse.rb(OptionParser#permute): ignored arguments after `--'.

	* optparse.rb: Refined example code.

1999-12-19  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* optparse.rb: Adding boolean flag switch.

	* optparse.rb: Initial revision.

1998-01-16  Nobuyoshi Nakada  <nobu.nokada@softhome.net>

	* getopts.test: Original version for getopts.rb.

